#include <iostream>
#include "AlberoBinario.h"

using namespace std;

void initAlbero(Albero& a) {
	a = NULL;
}

void createRoot(Albero& a, int info) {
NodoAlbero* root = new NodoAlbero();
	root->father = NULL;
	root->left = NULL;
	root->right= NULL;
	root->info = info;
	a = root;
}

int isEmpty(Albero& a) {
	return (a == NULL);
}

NodoAlbero* getFather(NodoAlbero* x) {
	return x->father;
}

NodoAlbero* getLeft(NodoAlbero* x) {
	return x->left;
}

NodoAlbero* getRight(NodoAlbero* x) {
	return x->right;
}

NodoAlbero* insert(NodoAlbero* x, int info) {
	if (x->right==NULL) {
		NodoAlbero* node = new NodoAlbero();
		node->father = x;
		node->left = NULL;
		node->right = NULL;
		node->info = info;
		x->right = node;
		return node;
	}
	else if (x->left==NULL) {
		NodoAlbero* node = new NodoAlbero();
		node->father = x;
		node->left = NULL;
		node->right = NULL;
		node->info = info;
		x->left = node;
		return node;
	}
	else
		return NULL;
}

void del(NodoAlbero* x) {
	if (x->left==NULL && x->right==NULL) {
		(x->father)->left = NULL;
		(x->father)->right =NULL;
		delete(x);
	}
}

void deallocaAlbero(Albero& a) {
	if( a!=NULL ) {
    		deallocaAlbero(a->left);
    		deallocaAlbero(a->right);
  	}
  	delete(a);
}
