#include <iostream>
#include "Coda.h"

using namespace std;

void InitCoda(Coda& cod) {
   cod = NULL;
}

void InsertCoda(Coda& cod, NodoAlbero elem) {
	NodoCoda* ultimo;
	NodoCoda* paux;

	paux = new NodoCoda();
	paux->info = elem;
	paux->next = NULL;

	if (cod == NULL) 
		cod = paux;
	else {
		ultimo = cod;
		while (ultimo->next != NULL) 
			ultimo = ultimo->next;
		ultimo->next = paux;
	}
}

void ExtractCoda(Coda& cod, NodoAlbero& elem) {
	NodoCoda* ret;

	if (cod != NULL) {
		elem = cod->info;
		ret = cod;
		cod = cod->next;
		delete(ret);
	}
}

int EmptyCoda(Coda& cod) {
	return (cod==NULL);
}
