#include <iostream>
#include "lista.h"

using namespace std;

/* funzione di utilita */
void StampaLista(Lista& l) {
  NodoLista* paux;
  paux = l;
  while(paux!=NULL) {
    cout << paux-> info << '\t';
    paux = paux->next;
  }
  cout << endl;
}

int nRip (Lista lis, int k){
 int n; // risultato del conteggio 
 n = 0;
 while ( lis != NULL) {
 if ( lis -> info == k )
 n=n+1;
 lis = lis -> next;
 }
 return n;
 }
 
 int nRipetizioniMassime (Lista& lis, int *valMax) {
 int nMax; // no. max ripetizioni trovato finora
 int n;
 // risultato di ogni conteggio 
 nMax = 0;
 while ( lis != NULL) {
 n = nRip(lis, lis -> info);
 if ( n > nMax ) { // trovato elemento con massimo di ripetizioni 
   *valMax = lis -> info;
   nMax = n;
   }
   lis = lis -> next;
   }
   return nMax;
 }
 

int main() {
  Lista l;
  int x;
  
  cout << "Init Lista" << endl;
  InitLista(l);
  StampaLista(l);
  cout << "InsTesta 1" << endl;
  InsTesta(l, 1);
  StampaLista(l);
  cout << "InsTesta 2" << endl;
  InsTesta(l, 2);
  StampaLista(l);
  cout << "InsTesta 3" << endl;
  InsTesta(l, 3);
  StampaLista(l);
  cout << "InsCoda 4" << endl;
  InsCoda(l, 4);
  StampaLista(l);
  cout << "InsTesta 5" << endl;
  InsCoda(l, 5);
  StampaLista(l);
  cout << "InsPos 6 in [3]" << endl;
  InsPos(l, 6, 3);
  
  InsCoda(l, 4);
  StampaLista(l);
  cout << "InsTesta 5" << endl;
  
  InsCoda(l, 4);
  StampaLista(l);
  cout << "InsTesta 5" << endl;
  
  InsCoda(l, 4);
  StampaLista(l);
  cout << "InsTesta 5" << endl;
  
  InsCoda(l, 4);
  StampaLista(l);
  cout << "InsTesta 5" << endl;
  
  
  StampaLista(l);
  int num = 4;
  int n = nRipetizioniMassime(l, &num);
  cout << "il numero " << num << " e' ripetuto " << n << " volte" << endl;
  
  //system("pause");
  
  return 0;
}
