#include <iostream>
#include "Coda.h"
using namespace std;



void VisitaAlberoProfondita(Albero& a) {
	if (a == NULL)
		return;
	cout << a->info << '\t';
	VisitaAlberoProfondita(a->left);
	VisitaAlberoProfondita(a->right);
 }

void VisitaAlberoAmpiezza(Albero& a) {
	Coda c;
	InitCoda(c);
	NodoAlbero* nr = getRight(a);
	NodoAlbero* nl = getLeft(a);
	
	cout << endl;
	cout << a->info << '\t';;

	if (nr!=NULL)
		InsertCoda(c, *nr);
	if (nr!=NULL)
		InsertCoda(c, *nl);
		
	while (!EmptyCoda(c)) {
		NodoAlbero n;
		ExtractCoda(c, n);
		
		cout << n.info << '\t';
		
		NodoAlbero* nnr = getRight(&n);
		NodoAlbero* nnl = getLeft(&n);
		
		if (nnr!=NULL)
			InsertCoda(c, *nnr);
		if (nnl!=NULL)
			InsertCoda(c, *nnl);
	}
	
}

int main() {
	Albero a;
	//NodoAlbero na;
	
	initAlbero(a);
	createRoot(a, 1);
	NodoAlbero* n1 = insert(a,2);
	NodoAlbero* n2 = insert(a,3);
	NodoAlbero* n3 = insert(n2,4);
	NodoAlbero* n4 = insert(n2,5);
	VisitaAlberoProfondita(a);
	//VisitaAlberoAmpiezza(a);
	
	//NodoAlbero* nr = Right(n1);
	//cout << endl << nr->info;
    
   // system("pause");
	return 0;
	
}
