#include <iostream>
#include "Lista.h"
#include "AlberoBinario.h"

using namespace std;

void StampaLista(Lista& l) {
  NodoLista* paux;
  paux = l;
  while(paux!=NULL) {
    cout << paux-> info << '\t';
    paux = paux->next;
  }
  cout << endl;
}

void VisitaAlberoProfondita(Albero& a) {
  if (a == NULL)
    return;
  cout << a->info << '\t';
  VisitaAlberoProfondita(a->left);
  VisitaAlberoProfondita(a->right);
}
/*
Questo metodo visita un albero e ne copia gli elementi figli destri in una lista
*/
void copiaAlberoInLista(Albero& a, Lista& l, bool destro){
  if(a == NULL) return;
  cout<<"considering "<<a->info << " *right: " << a->right->info << " *left: " << a->left->info << endl;
  //aggiungiamo nella lista il nodo attuale se e' figlio destro
  if(destro)
    InsCoda(l, a->info);
  copiaAlberoInLista(a->left, l, false);
  copiaAlberoInLista(a->right, l, true);
}

int main(){
  //dichiaro la mia lista
  Lista l;
  //e la inizializzo
  InitLista(l);
  
  Albero a;
  //NodoAlbero na;
  
  initAlbero(a);
  createRoot(a, 1);
  NodoAlbero* n1 = insert(a,2);
  NodoAlbero* n2 = insert(a,3);
  NodoAlbero* n3 = insert(n2,4);
  NodoAlbero* n4 = insert(n2,5);
  
  copiaAlberoInLista(a, l, true);
  
  StampaLista(l);
  
}
  
  
  
  
  